



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ElasticSearch入门 第六篇：复合数据类型——数组，对象和嵌套</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ElasticSearch入门 第六篇：复合数据类型——数组，对象和嵌套</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 10:46:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这是ElasticSearch 2.4 版本系列的第六篇：</p>
<ul><li><a href="http://www.cnblogs.com/ljhdo/p/4887557.html" rel="external nofollow noreferrer">ElasticSearch入门 第一篇：Windows下安装ElasticSearch</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/4959412.html" rel="external nofollow noreferrer">ElasticSearch入门 第二篇：集群配置</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/4981928.html" rel="external nofollow noreferrer">ElasticSearch入门 第三篇：索引</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/5160329.html" rel="external nofollow noreferrer">ElasticSearch入门 第四篇：使用C#添加和更新文档</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/4550135.html" rel="external nofollow noreferrer">ElasticSearch入门 第五篇：使用C#查询文档</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/4904430.html" rel="external nofollow noreferrer">ElasticSearch入门 第六篇：复合数据类型&mdash;&mdash;数组，对象和嵌套</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/5012510.html" rel="external nofollow noreferrer">ElasticSearch入门 第七篇：分析器</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/5016852.html" rel="external nofollow noreferrer">ElasticSearch入门 第八篇：存储</a></li>
<li><a href="http://www.cnblogs.com/ljhdo/p/4911878.html" rel="external nofollow noreferrer">ElasticSearch入门 第九篇：实现正则表达式查询的思路</a></li></ul>
<p>在ElasticSearch中，使用JSON结构来存储数据，一个Key/Value对是JSON的一个字段，而Value可以是基础数据类型，也可以是数组，文档（也叫对象），或文档数组，因此，每个JSON文档都内在地具有层次结构。复合数据类型是指数组类型，对象类型和嵌套类型，各个类型的特点分别是：</p>
<ul><li>数组字段是指一个字段有多个值，每个值都是该数组字段的一个元素；元素的类型可以是基础类型，也可以是文档类型；</li>
<li>对象类型是指字段的值是一个JSON文档；</li>
<li>嵌套字段是指对象类型的一个特殊版本，ElasticSearch引擎在内部把嵌套字段索引成单个文档。如果在嵌套字段中定义对象数组，那么对象数组中的每个元素（文档）都被索引成单个文档，每个文档都能被独立地查询。</li></ul>
<p><strong>一，对象类型</strong></p>
<p>JSON文档是有层次结构的，一个文档可能包含其他文档，如果一个文档包含其他文档，那么该文档值是对象类型，其数据类型是对象，ElasticSearch默认把文档的属性type设置为object，即"type":"object"。</p>
<p>例如，在创建索引映时，定义name字段为对象类型，不需要显式定义type属性值，其默认值是object：</p>
<div>
<pre class="prettyprint linenums">"manager":{<br />
   "properties":{<br />
      "age":{ "type":"integer"},<br />
      "name":{<br />
         "properties":{<br />
            "first":{"type":"string"},<br />
            "last":{ "type":"string"}<br />
         }<br />
      }<br />
   }<br />
}</pre>
</div>
<p>默认情况下，上述文档类型被索引为以点号命名的数据结构，把层次结构展开之后，数据结构是由扁平的key/value对构成：</p>
<div>
<pre class="prettyprint linenums">{<br />
  "manager.age":        ,<br />
  "manager.name.first": "John",<br />
  "manager.name.last":  "Smith"<br />
}</pre>
</div>
<p><strong>二，开箱即用的数组类型</strong></p>
<p>在ElasticSearch中，没有专门的数组（Array）数据类型，但是，在默认情况下，任意一个字段都可以包含0或多个值，这意味着每个字段默认都是数组类型，只不过，数组类型的各个元素值的数据类型必须相同。在ElasticSearch中，数组是开箱即用的（out of box），不需要进行任何配置，就可以直接使用。</p>
<p><strong>1，数组类型</strong></p>
<p>在同一个数组中，数组元素的数据类型是相同的，ElasticSearch不支持元素为多个数据类型：[ 10, "some string" ]，常用的数组类型是：</p>
<div>
<ul><li>字符数组: [ "one", "two" ]</li>
<li>整数数组: productid:[ 1, 2 ]</li>
<li>对象（文档）数组: "user":[ { "name": "Mary", "age": 12 }, { "name": "John", "age": 10 }]，ElasticSearch内部把对象数组展开为 {"user.name": ["Mary", "John"], "user.age": [12,10]}</li></ul>
</div>
<p>对于文档数组，每个元素都是结构相同的文档，文档之间都不是独立的，在文档数组中，不能独立于其他文档而去查询单个文档，这是因为，一个文档的内部字段之间的关联被移除，各个文档共同构成对象数组。</p>
<p>对整数数组进行查询，例如，使用多词条（terms）查询类型，查询productid为1和2的文档：</p>
<div>
<pre class="prettyprint linenums">{<br />
   "query":{<br />
      "terms":{<br />
         "productid":[ ,  ]<br />
      }<br />
   }<br />
}</pre>
</div>
<p><strong>2，对象数组</strong></p>
<p>通过PUT动词，自动创建索引和文档类型，在文档中创建对象数组：</p>
<div>
<pre class="prettyprint linenums">PUT my_index/my_type/<br />
{<br />
  "group" : "fans",<br />
  "user" : [<br />
    {<br />
      "first" : "John",<br />
      "last" :  "Smith"<br />
    },<br />
    {<br />
      "first" : "Alice",<br />
      "last" :  "White"<br />
    }<br />
  ]<br />
}</pre>
</div>
<p>ElasticSearch引擎内部把对象数组展开成扁平的数据结构，把上例的文档类型的数据结构展开之后，文档数据类似于：</p>
<div>
<pre class="prettyprint linenums">{<br />
  "group" :        "fans",<br />
  "user.first" : [ "alice", "john" ],<br />
  "user.last" :  [ "smith", "white" ]<br />
}</pre>
</div>
<p>字段&nbsp;user.first 和 user.last 被展开成数组字段，但是，这样展开之后，单个文档内部的字段之间的关联就会丢失，在该例中，展开的文档数据丢失first和last字段之间的关联，比如，A<code>lice</code>&nbsp;和&nbsp;<code>white</code>&nbsp;的关联就丢失了。</p>
<p><strong>三，嵌套数据类型</strong></p>
<p>嵌套数据类型是对象数据类型的特殊版本，它允许对象数组中的各个对象被索引，数组中的各个对象之间保持独立，能够对每一个文档进行单独查询，这就意味着，嵌套数据类型保留文档的内部之间的关联，ElasticSearch引擎内部使用不同的方式处理嵌套数据类型和对象数组的方式，对于嵌套数据类型，ElasticSearch把数组中的每一个嵌套文档（Nested Document）索引为单个文档，这些文档是隐藏（Hidden）的，文档之间是相互独立的，但是，保留文档的内部字段之间的关联，使用嵌套查询（Nested Query）能够独立于其他文档而去查询单个文档。在创建嵌套数据类型的字段时，需要设置字段的type属性为nested。</p>
<p><strong>1，在索引映射中创建嵌套字段</strong></p>
<p>设置user字段为嵌套数据类型，由于每个字段默认都可以是数组类型，因此，嵌套字段也可以是对象数组。</p>
<div>
<pre class="prettyprint linenums">"mappings":{<br />
   "my_type":{<br />
      "properties":{<br />
         "group":{ "type":"string"},<br />
         "user":{<br />
            "type":"nested",<br />
            "properties":{<br />
               "first":{ "type":"string"},<br />
               "second":{  "type":"string"}<br />
            }<br />
         }<br />
      }<br />
   }<br />
}</pre>
</div>
<p><strong>2，为嵌套字段赋值</strong></p>
<p>为嵌套字段赋予多个值，那么ElasticSearch自动把字段值转换为数组类型。</p>
<div>
<pre class="prettyprint linenums">PUT my_index/my_type/<br />
{<br />
  "group" : "fans",<br />
  "user" : [<br />
    { "first" : "John", "last" :  "Smith"},<br />
    { "first" : "Alice", "last" :  "White"}<br />
  ]<br />
}</pre>
</div>
<p>在ElasticSearch内部，嵌套的文档（Nested Documents）被索引为很多独立的隐藏文档（separate documents），这些隐藏文档只能通过嵌套查询（Nested Query）访问。每一个嵌套的文档都是嵌套字段（文档数组）的一个元素。嵌套文档的内部字段之间的关联被ElasticSearch引擎保留，而嵌套文档之间是相互独立的。在该例中，ElasticSearch引起保留Alice和White之间的关联，而John和White之间是没有任何关联的。</p>
<p>默认情况下，每个索引最多创建50个嵌套文档，可以通过索引设置选项：index.mapping.nested_fields.limit 修改默认的限制。</p>
<blockquote><p>Indexing a document with 100 nested fields actually indexes 101 documents as each nested document is indexed as a separate document.</p></blockquote>
<p><strong>四，嵌套查询</strong></p>
<p>嵌套查询用于查询嵌套对象，执行嵌套查询执行的条件是：嵌套对象被索引为单个文档，查询作用在根文档（Root Parent）上。嵌套查询由关键字&ldquo;nested&rdquo;指定：</p>
<div>
<pre class="prettyprint linenums">"nested" : {<br />
        "path" : "obj1",<br />        "query" : {...}</pre>
</div>
<p><strong>1，必须赋值的参数：</strong></p>
<ul><li>path参数：指定嵌套字段的文档路径，根路径是顶层的文档，通过点号&ldquo;.&rdquo;来指定嵌套文档的路径；</li>
<li>query参数：在匹配路径（参数path）的嵌套文档上执行查询，query参数指定对嵌套文档执行的查询条件。</li></ul>
<p><strong>2，使用嵌套查询访问嵌套文档</strong></p>
<div>
<pre class="prettyprint linenums">GET my_index/_search<br />
{<br />
  "query": {<br />
    "nested": {<br />
      "path": "user",<br />
      "query": {<br />
        "bool": {<br />
          "must": [<br />
            { "match": { "user.first": "Alice" }},<br />
            { "match": { "user.last":  "White" }}<br />
          ]<br />
        }<br />
      }<br />
    }<br />
  }<br />
}</pre>
</div>
<p><strong>五，使用C#索引数组类型</strong></p>
<p><strong>1，创建ElasticSearch的索引映射</strong></p>
<div>
<div>
<pre class="prettyprint linenums">{<br />
   "settings":{<br />
      "number_of_shards":,<br />
      "number_of_replicas":<br />
   },<br />
   "mappings":{<br />
      "events":{<br />
        "dynamic":"false",<br />
         "properties":{<br />
            "eventid":{<br />
               "type":"long",<br />
               "store":true,<br />
               "index":"not_analyzed"<br />
            },<br />
            "eventname":{<br />
               "type":"string",<br />
               "store":true,<br />
               "index":"analyzed",<br />
               "fields":{<br />
                  "raw":{<br />
                     "type":"string",<br />
                     "store":true,<br />
                     "index":"not_analyzed"<br />
                  }<br />
               }<br />
            },<br />
            "topics":{<br />
               "type":"integer",<br />
               "store":true,<br />
               "index":"analyzed"<br />
            }<br />
         }<br />
      }<br />
   }<br />
}</pre>
</div>
</div>
<p>对于topics字段，类型是integer，赋予其一组整数值[1,2,3]，那么该字段就能存储数组。</p>
<div>
<pre class="prettyprint linenums">"topics":{<br />
    "type":"integer",<br />
    "store":true,<br />
    "index":"analyzed"<br />
}</pre>
</div>
<p><strong>2，创建数据模型（Data Model）</strong></p>
<p>为数组字段定义为List类型，每个列表项的数据类型是int。</p>
<div>
<pre class="prettyprint linenums">public class EventBase<br />
{<br />
    public long eventid { get; set; }<br />
}

public class EbrieEvents:EventBase<br />
{<br />
    public string eventname { get; set; }<br />
    public List&lt;int&gt; topics { get; set; }<br />
}</pre>
</div>
<p><strong>3，为字段赋值</strong></p>
<p>为List字段topics赋值，调用NEST对该文档进行索引</p>
<div>
<pre class="prettyprint linenums">EbrieEvents pb = new EbrieEvents();

//Topics List<br />
List&lt;string&gt; strTopics = TableRow["Topics"].ToString().TrimEnd(',').Split(',').ToList();<br />
List&lt;int&gt; topics = new List&lt;int&gt;();<br />
foreach(string str in strTopics)<br />
{<br />
    topics.Add(int.Parse(str));<br />
}<br />
pb.topics = topics;  </pre>
</div>
<p><strong>4，查询数组字段</strong></p>
<div>
<pre class="prettyprint linenums">{<br />
   "query":{<br />
      "terms":{<br />
         "topics":[,]<br />
      }<br />
   }<br />
}</pre>
</div>
<p>参考文档：</p>
<p><a href="https://www.elastic.co/guide/en/elasticsearch/reference/2.4/mapping-types.html" rel="external nofollow noreferrer">Elasticsearch Reference [2.4] &raquo; Mapping &raquo; Field datatypes</a></p>
<p><a href="https://www.elastic.co/guide/en/elasticsearch/reference/2.4/query-dsl-nested-query.html" rel="external nofollow noreferrer">Elasticsearch Reference [2.4] &raquo; Query DSL &raquo; Joining queries &raquo; Nested Query</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxnrzz8.html">Android 解析聊天表情的笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kj3679.html">51nod 算法马拉松18 B 非010串 矩阵快速幂</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2kgn3q.html">HTML基本组成结构与标签的认识</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld0wk9.html">Python 学习笔记01</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw2dy9.html">SQL serve  聚合函数、字符串函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5mmg8.html">【JavaScript回顾】闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjn3249.html">影响SQL server性能的关键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppx6jq.html">《学习opencv》笔记&mdash;&mdash;矩阵和图像处理&mdash;&mdash;cvGEMM&comma;cvGetCol&comma;cvGetCols and cvGetDiag</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zpxzj9.html">关于CSS样式的那些事&lowbar;导航条菜单讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5oyk8.html">my first blogs&lpar;我的处女博&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjewkk8.html">POJ 3050 Hopscotch  DFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjrn5x8.html">移动端滑动效果 swiper 4&period;0&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdo0e9.html">Django项目和Django初体验和创建、目录结构认识</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25yx23q.html">Kafka自带zookeeper报错INFO Got user-level KeeperException when processing xxx Error Path&colon;&sol;brokers Error&colon;KeeperErrorCode &equals; NodeExists for &sol;brokers &lpar;org&period;apache&period;zookeeper&period;server&period;PrepRequestProcessor&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25l10xq.html">Excel vba map&sol;dictionary</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4xpd8.html">关于js函数，方法，对象实例的一些说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r3d068.html">Unity 3D-AR开发-Vuforia教程手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pnn3jq.html">Supervisor 配置过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4yp0pq.html">D03&mdash;&mdash;C语言基础学习PYTHON</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn2x4mq.html">超赞的 Go 语言 INI 文件操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gj6k3z9.html">几种php加速器比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvpx0r8.html">Linux性能分析流程图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1popxq.html">通俗理解word2vec</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j16rde9.html">vmware中如何检查cpu的使用状况-一个考题引发的思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25eewoq.html">1&period;5&period;3 GROUP BY子句</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw66gz8.html">array2json&lpar;&rpar; - Convert PHP arrays to JSON</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wrr3gq.html">【PMP】项目浮动的三种时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zypp6x9.html">【Java】MyBatis与Spring框架整合（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zypp519.html">GitHub下载安装以及开源项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyp7r39.html">CSS中的偏僻知识点</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
